oidtree: avoid nested struct oidtree_node
[git/debian.git] / t / test-lib.sh
blob54938c642790d8d0a8f052ef57e0556cf4104ce5
1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
26 else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
45 export ASAN_OPTIONS
47 # If LSAN is in effect we _do_ want leak checking, but we still
48 # want to abort so that we notice the problems.
49 : ${LSAN_OPTIONS=abort_on_error=1}
50 export LSAN_OPTIONS
52 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
53 then
54 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
55 exit 1
57 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58 export PERL_PATH SHELL_PATH
60 # Disallow the use of abbreviated options in the test suite by default
61 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
62 then
63 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
64 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
67 # Explicitly set the default branch name for testing, to avoid the
68 # transitory "git init" warning under --verbose.
69 : ${GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME:=master}
70 export GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME
72 ################################################################
73 # It appears that people try to run tests without building...
74 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
75 if test $? != 1
76 then
77 if test -n "$GIT_TEST_INSTALLED"
78 then
79 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
80 else
81 echo >&2 'error: you do not seem to have built git yet.'
83 exit 1
86 store_arg_to=
87 opt_required_arg=
88 # $1: option string
89 # $2: name of the var where the arg will be stored
90 mark_option_requires_arg () {
91 if test -n "$opt_required_arg"
92 then
93 echo "error: options that require args cannot be bundled" \
94 "together: '$opt_required_arg' and '$1'" >&2
95 exit 1
97 opt_required_arg=$1
98 store_arg_to=$2
101 parse_option () {
102 local opt="$1"
104 case "$opt" in
105 -d|--d|--de|--deb|--debu|--debug)
106 debug=t ;;
107 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
108 immediate=t ;;
109 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
110 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
112 mark_option_requires_arg "$opt" run_list
114 --run=*)
115 run_list=${opt#--*=} ;;
116 -h|--h|--he|--hel|--help)
117 help=t ;;
118 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
119 verbose=t ;;
120 --verbose-only=*)
121 verbose_only=${opt#--*=}
123 -q|--q|--qu|--qui|--quie|--quiet)
124 # Ignore --quiet under a TAP::Harness. Saying how many tests
125 # passed without the ok/not ok details is always an error.
126 test -z "$HARNESS_ACTIVE" && quiet=t ;;
127 --with-dashes)
128 with_dashes=t ;;
129 --no-bin-wrappers)
130 no_bin_wrappers=t ;;
131 --no-color)
132 color= ;;
133 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
134 valgrind=memcheck
135 tee=t
137 --valgrind=*)
138 valgrind=${opt#--*=}
139 tee=t
141 --valgrind-only=*)
142 valgrind_only=${opt#--*=}
143 tee=t
145 --tee)
146 tee=t ;;
147 --root=*)
148 root=${opt#--*=} ;;
149 --chain-lint)
150 GIT_TEST_CHAIN_LINT=1 ;;
151 --no-chain-lint)
152 GIT_TEST_CHAIN_LINT=0 ;;
154 trace=t ;;
155 -V|--verbose-log)
156 verbose_log=t
157 tee=t
159 --write-junit-xml)
160 write_junit_xml=t
162 --stress)
163 stress=t ;;
164 --stress=*)
165 echo "error: --stress does not accept an argument: '$opt'" >&2
166 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
167 exit 1
169 --stress-jobs=*)
170 stress=t;
171 stress_jobs=${opt#--*=}
172 case "$stress_jobs" in
173 *[!0-9]*|0*|"")
174 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
175 exit 1
177 *) # Good.
179 esac
181 --stress-limit=*)
182 stress=t;
183 stress_limit=${opt#--*=}
184 case "$stress_limit" in
185 *[!0-9]*|0*|"")
186 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
187 exit 1
189 *) # Good.
191 esac
194 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
195 esac
198 # Parse options while taking care to leave $@ intact, so we will still
199 # have all the original command line options when executing the test
200 # script again for '--tee' and '--verbose-log' later.
201 for opt
203 if test -n "$store_arg_to"
204 then
205 eval $store_arg_to=\$opt
206 store_arg_to=
207 opt_required_arg=
208 continue
211 case "$opt" in
212 --*|-?)
213 parse_option "$opt" ;;
214 -?*)
215 # bundled short options must be fed separately to parse_option
216 opt=${opt#-}
217 while test -n "$opt"
219 extra=${opt#?}
220 this=${opt%$extra}
221 opt=$extra
222 parse_option "-$this"
223 done
226 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
227 esac
228 done
229 if test -n "$store_arg_to"
230 then
231 echo "error: $opt_required_arg requires an argument" >&2
232 exit 1
235 if test -n "$valgrind_only"
236 then
237 test -z "$valgrind" && valgrind=memcheck
238 test -z "$verbose" && verbose_only="$valgrind_only"
239 elif test -n "$valgrind"
240 then
241 test -z "$verbose_log" && verbose=t
244 if test -n "$stress"
245 then
246 verbose=t
247 trace=t
248 immediate=t
251 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
252 TEST_NAME="$(basename "$0" .sh)"
253 TEST_NUMBER="${TEST_NAME%%-*}"
254 TEST_NUMBER="${TEST_NUMBER#t}"
255 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
256 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
257 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
258 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
259 case "$TRASH_DIRECTORY" in
260 /*) ;; # absolute path is good
261 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
262 esac
264 # If --stress was passed, run this test repeatedly in several parallel loops.
265 if test "$GIT_TEST_STRESS_STARTED" = "done"
266 then
267 : # Don't stress test again.
268 elif test -n "$stress"
269 then
270 if test -n "$stress_jobs"
271 then
272 job_count=$stress_jobs
273 elif test -n "$GIT_TEST_STRESS_LOAD"
274 then
275 job_count="$GIT_TEST_STRESS_LOAD"
276 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
277 test -n "$job_count"
278 then
279 job_count=$((2 * $job_count))
280 else
281 job_count=8
284 mkdir -p "$TEST_RESULTS_DIR"
285 stressfail="$TEST_RESULTS_BASE.stress-failed"
286 rm -f "$stressfail"
288 stress_exit=0
289 trap '
290 kill $job_pids 2>/dev/null
291 wait
292 stress_exit=1
293 ' TERM INT HUP
295 job_pids=
296 job_nr=0
297 while test $job_nr -lt "$job_count"
300 GIT_TEST_STRESS_STARTED=done
301 GIT_TEST_STRESS_JOB_NR=$job_nr
302 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
304 trap '
305 kill $test_pid 2>/dev/null
306 wait
307 exit 1
308 ' TERM INT
310 cnt=1
311 while ! test -e "$stressfail" &&
312 { test -z "$stress_limit" ||
313 test $cnt -le $stress_limit ; }
315 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
316 test_pid=$!
318 if wait $test_pid
319 then
320 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
321 else
322 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
323 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
325 cnt=$(($cnt + 1))
326 done
328 job_pids="$job_pids $!"
329 job_nr=$(($job_nr + 1))
330 done
332 wait
334 if test -f "$stressfail"
335 then
336 stress_exit=1
337 echo "Log(s) of failed test run(s):"
338 for failed_job_nr in $(sort -n "$stressfail")
340 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
341 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
342 done
343 rm -rf "$TRASH_DIRECTORY.stress-failed"
344 # Move the last one.
345 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
348 exit $stress_exit
351 # if --tee was passed, write the output not only to the terminal, but
352 # additionally to the file test-results/$BASENAME.out, too.
353 if test "$GIT_TEST_TEE_STARTED" = "done"
354 then
355 : # do not redirect again
356 elif test -n "$tee"
357 then
358 mkdir -p "$TEST_RESULTS_DIR"
360 # Make this filename available to the sub-process in case it is using
361 # --verbose-log.
362 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
363 export GIT_TEST_TEE_OUTPUT_FILE
365 # Truncate before calling "tee -a" to get rid of the results
366 # from any previous runs.
367 >"$GIT_TEST_TEE_OUTPUT_FILE"
369 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
370 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
371 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
372 exit
375 if test -n "$trace" && test -n "$test_untraceable"
376 then
377 # '-x' tracing requested, but this test script can't be reliably
378 # traced, unless it is run with a Bash version supporting
379 # BASH_XTRACEFD (introduced in Bash v4.1).
381 # Perform this version check _after_ the test script was
382 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
383 # '--verbose-log', so the right shell is checked and the
384 # warning is issued only once.
385 if test -n "$BASH_VERSION" && eval '
386 test ${BASH_VERSINFO[0]} -gt 4 || {
387 test ${BASH_VERSINFO[0]} -eq 4 &&
388 test ${BASH_VERSINFO[1]} -ge 1
391 then
392 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
393 else
394 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
395 trace=
398 if test -n "$trace" && test -z "$verbose_log"
399 then
400 verbose=t
403 # For repeatability, reset the environment to known value.
404 # TERM is sanitized below, after saving color control sequences.
405 LANG=C
406 LC_ALL=C
407 PAGER=cat
408 TZ=UTC
409 export LANG LC_ALL PAGER TZ
410 EDITOR=:
412 # A call to "unset" with no arguments causes at least Solaris 10
413 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
414 # deriving from the command substitution clustered with the other
415 # ones.
416 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
417 my @env = keys %ENV;
418 my $ok = join("|", qw(
419 TRACE
420 DEBUG
421 TEST
422 .*_TEST
423 PROVE
424 VALGRIND
425 UNZIP
426 PERF_
427 CURL_VERBOSE
428 TRACE_CURL
430 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
431 print join("\n", @vars);
433 unset XDG_CACHE_HOME
434 unset XDG_CONFIG_HOME
435 unset GITPERLLIB
436 TEST_AUTHOR_LOCALNAME=author
437 TEST_AUTHOR_DOMAIN=example.com
438 GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
439 GIT_AUTHOR_NAME='A U Thor'
440 GIT_AUTHOR_DATE='1112354055 +0200'
441 TEST_COMMITTER_LOCALNAME=committer
442 TEST_COMMITTER_DOMAIN=example.com
443 GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
444 GIT_COMMITTER_NAME='C O Mitter'
445 GIT_COMMITTER_DATE='1112354055 +0200'
446 GIT_MERGE_VERBOSITY=5
447 GIT_MERGE_AUTOEDIT=no
448 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
449 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
450 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
451 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
452 export EDITOR
454 GIT_DEFAULT_HASH="${GIT_TEST_DEFAULT_HASH:-sha1}"
455 export GIT_DEFAULT_HASH
456 GIT_TEST_MERGE_ALGORITHM="${GIT_TEST_MERGE_ALGORITHM:-ort}"
457 export GIT_TEST_MERGE_ALGORITHM
459 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
460 GIT_TRACE_BARE=1
461 export GIT_TRACE_BARE
463 # Use specific version of the index file format
464 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
465 then
466 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
467 export GIT_INDEX_VERSION
470 if test -n "$GIT_TEST_PERL_FATAL_WARNINGS"
471 then
472 GIT_PERL_FATAL_WARNINGS=1
473 export GIT_PERL_FATAL_WARNINGS
476 # Add libc MALLOC and MALLOC_PERTURB test
477 # only if we are not executing the test with valgrind
478 if test -n "$valgrind" ||
479 test -n "$TEST_NO_MALLOC_CHECK"
480 then
481 setup_malloc_check () {
482 : nothing
484 teardown_malloc_check () {
485 : nothing
487 else
488 setup_malloc_check () {
489 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
490 export MALLOC_CHECK_ MALLOC_PERTURB_
492 teardown_malloc_check () {
493 unset MALLOC_CHECK_ MALLOC_PERTURB_
497 # Protect ourselves from common misconfiguration to export
498 # CDPATH into the environment
499 unset CDPATH
501 unset GREP_OPTIONS
502 unset UNZIP
504 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
505 1|2|true)
506 GIT_TRACE=4
508 esac
510 # Line feed
511 LF='
514 # Single quote
515 SQ=\'
517 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
518 # when case-folding filenames
519 u200c=$(printf '\342\200\214')
521 export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
523 # Each test should start with something like this, after copyright notices:
525 # test_description='Description of this test...
526 # This test checks if command xyzzy does the right thing...
528 # . ./test-lib.sh
529 test "x$TERM" != "xdumb" && (
530 test -t 1 &&
531 tput bold >/dev/null 2>&1 &&
532 tput setaf 1 >/dev/null 2>&1 &&
533 tput sgr0 >/dev/null 2>&1
534 ) &&
535 color=t
537 if test -n "$color"
538 then
539 # Save the color control sequences now rather than run tput
540 # each time say_color() is called. This is done for two
541 # reasons:
542 # * TERM will be changed to dumb
543 # * HOME will be changed to a temporary directory and tput
544 # might need to read ~/.terminfo from the original HOME
545 # directory to get the control sequences
546 # Note: This approach assumes the control sequences don't end
547 # in a newline for any terminal of interest (command
548 # substitutions strip trailing newlines). Given that most
549 # (all?) terminals in common use are related to ECMA-48, this
550 # shouldn't be a problem.
551 say_color_error=$(tput bold; tput setaf 1) # bold red
552 say_color_skip=$(tput setaf 4) # blue
553 say_color_warn=$(tput setaf 3) # brown/yellow
554 say_color_pass=$(tput setaf 2) # green
555 say_color_info=$(tput setaf 6) # cyan
556 say_color_reset=$(tput sgr0)
557 say_color_="" # no formatting for normal text
558 say_color () {
559 test -z "$1" && test -n "$quiet" && return
560 eval "say_color_color=\$say_color_$1"
561 shift
562 printf "%s\\n" "$say_color_color$*$say_color_reset"
564 else
565 say_color() {
566 test -z "$1" && test -n "$quiet" && return
567 shift
568 printf "%s\n" "$*"
572 TERM=dumb
573 export TERM
575 error () {
576 say_color error "error: $*"
577 finalize_junit_xml
578 GIT_EXIT_OK=t
579 exit 1
582 BUG () {
583 error >&7 "bug in the test script: $*"
586 say () {
587 say_color info "$*"
590 if test -n "$HARNESS_ACTIVE"
591 then
592 if test "$verbose" = t || test -n "$verbose_only"
593 then
594 printf 'Bail out! %s\n' \
595 'verbose mode forbidden under TAP harness; try --verbose-log'
596 exit 1
600 test "${test_description}" != "" ||
601 error "Test script did not set test_description."
603 if test "$help" = "t"
604 then
605 printf '%s\n' "$test_description"
606 exit 0
609 exec 5>&1
610 exec 6<&0
611 exec 7>&2
612 if test "$verbose_log" = "t"
613 then
614 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
615 elif test "$verbose" = "t"
616 then
617 exec 4>&2 3>&1
618 else
619 exec 4>/dev/null 3>/dev/null
622 # Send any "-x" output directly to stderr to avoid polluting tests
623 # which capture stderr. We can do this unconditionally since it
624 # has no effect if tracing isn't turned on.
626 # Note that this sets up the trace fd as soon as we assign the variable, so it
627 # must come after the creation of descriptor 4 above. Likewise, we must never
628 # unset this, as it has the side effect of closing descriptor 4, which we
629 # use to show verbose tests to the user.
631 # Note also that we don't need or want to export it. The tracing is local to
632 # this shell, and we would not want to influence any shells we exec.
633 BASH_XTRACEFD=4
635 test_failure=0
636 test_count=0
637 test_fixed=0
638 test_broken=0
639 test_success=0
641 test_external_has_tap=0
643 die () {
644 code=$?
645 # This is responsible for running the atexit commands even when a
646 # test script run with '--immediate' fails, or when the user hits
647 # ctrl-C, i.e. when 'test_done' is not invoked at all.
648 test_atexit_handler || code=$?
649 if test -n "$GIT_EXIT_OK"
650 then
651 exit $code
652 else
653 echo >&5 "FATAL: Unexpected exit with code $code"
654 exit 1
658 GIT_EXIT_OK=
659 trap 'die' EXIT
660 # Disable '-x' tracing, because with some shells, notably dash, it
661 # prevents running the cleanup commands when a test script run with
662 # '--verbose-log -x' is interrupted.
663 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
665 # The user-facing functions are loaded from a separate file so that
666 # test_perf subshells can have them too
667 . "$TEST_DIRECTORY/test-lib-functions.sh"
669 # You are not expected to call test_ok_ and test_failure_ directly, use
670 # the test_expect_* functions instead.
672 test_ok_ () {
673 if test -n "$write_junit_xml"
674 then
675 write_junit_xml_testcase "$*"
677 test_success=$(($test_success + 1))
678 say_color "" "ok $test_count - $@"
681 test_failure_ () {
682 if test -n "$write_junit_xml"
683 then
684 junit_insert="<failure message=\"not ok $test_count -"
685 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
686 junit_insert="$junit_insert $(xml_attr_encode \
687 "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
688 then
689 test-tool path-utils skip-n-bytes \
690 "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
691 else
692 printf '%s\n' "$@" | sed 1d
693 fi)")"
694 junit_insert="$junit_insert</failure>"
695 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
696 then
697 junit_insert="$junit_insert<system-err>$(xml_attr_encode \
698 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
700 write_junit_xml_testcase "$1" " $junit_insert"
702 test_failure=$(($test_failure + 1))
703 say_color error "not ok $test_count - $1"
704 shift
705 printf '%s\n' "$*" | sed -e 's/^/# /'
706 test "$immediate" = "" || { finalize_junit_xml; GIT_EXIT_OK=t; exit 1; }
709 test_known_broken_ok_ () {
710 if test -n "$write_junit_xml"
711 then
712 write_junit_xml_testcase "$* (breakage fixed)"
714 test_fixed=$(($test_fixed+1))
715 say_color error "ok $test_count - $@ # TODO known breakage vanished"
718 test_known_broken_failure_ () {
719 if test -n "$write_junit_xml"
720 then
721 write_junit_xml_testcase "$* (known breakage)"
723 test_broken=$(($test_broken+1))
724 say_color warn "not ok $test_count - $@ # TODO known breakage"
727 test_debug () {
728 test "$debug" = "" || eval "$1"
731 match_pattern_list () {
732 arg="$1"
733 shift
734 test -z "$*" && return 1
735 for pattern_
737 case "$arg" in
738 $pattern_)
739 return 0
740 esac
741 done
742 return 1
745 match_test_selector_list () {
746 operation="$1"
747 shift
748 title="$1"
749 shift
750 arg="$1"
751 shift
752 test -z "$1" && return 0
754 # Commas are accepted as separators.
755 OLDIFS=$IFS
756 IFS=','
757 set -- $1
758 IFS=$OLDIFS
760 # If the first selector is negative we include by default.
761 include=
762 case "$1" in
763 !*) include=t ;;
764 esac
766 for selector
768 orig_selector=$selector
770 positive=t
771 case "$selector" in
773 positive=
774 selector=${selector##?}
776 esac
778 test -z "$selector" && continue
780 case "$selector" in
781 *-*)
782 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
783 then
784 echo "error: $operation: invalid non-numeric in range" \
785 "start: '$orig_selector'" >&2
786 exit 1
788 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
789 then
790 echo "error: $operation: invalid non-numeric in range" \
791 "end: '$orig_selector'" >&2
792 exit 1
796 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
797 then
798 case "$title" in *${selector}*)
799 include=$positive
801 esac
802 continue
804 esac
806 # Short cut for "obvious" cases
807 test -z "$include" && test -z "$positive" && continue
808 test -n "$include" && test -n "$positive" && continue
810 case "$selector" in
812 if test $arg -le ${selector#-}
813 then
814 include=$positive
818 if test $arg -ge ${selector%-}
819 then
820 include=$positive
823 *-*)
824 if test ${selector%%-*} -le $arg \
825 && test $arg -le ${selector#*-}
826 then
827 include=$positive
831 if test $arg -eq $selector
832 then
833 include=$positive
836 esac
837 done
839 test -n "$include"
842 maybe_teardown_verbose () {
843 test -z "$verbose_only" && return
844 exec 4>/dev/null 3>/dev/null
845 verbose=
848 last_verbose=t
849 maybe_setup_verbose () {
850 test -z "$verbose_only" && return
851 if match_pattern_list $test_count $verbose_only
852 then
853 exec 4>&2 3>&1
854 # Emit a delimiting blank line when going from
855 # non-verbose to verbose. Within verbose mode the
856 # delimiter is printed by test_expect_*. The choice
857 # of the initial $last_verbose is such that before
858 # test 1, we do not print it.
859 test -z "$last_verbose" && echo >&3 ""
860 verbose=t
861 else
862 exec 4>/dev/null 3>/dev/null
863 verbose=
865 last_verbose=$verbose
868 maybe_teardown_valgrind () {
869 test -z "$GIT_VALGRIND" && return
870 GIT_VALGRIND_ENABLED=
873 maybe_setup_valgrind () {
874 test -z "$GIT_VALGRIND" && return
875 if test -z "$valgrind_only"
876 then
877 GIT_VALGRIND_ENABLED=t
878 return
880 GIT_VALGRIND_ENABLED=
881 if match_pattern_list $test_count $valgrind_only
882 then
883 GIT_VALGRIND_ENABLED=t
887 trace_level_=0
888 want_trace () {
889 test "$trace" = t && {
890 test "$verbose" = t || test "$verbose_log" = t
894 # This is a separate function because some tests use
895 # "return" to end a test_expect_success block early
896 # (and we want to make sure we run any cleanup like
897 # "set +x").
898 test_eval_inner_ () {
899 # Do not add anything extra (including LF) after '$*'
900 eval "
901 want_trace && trace_level_=$(($trace_level_+1)) && set -x
905 test_eval_ () {
906 # If "-x" tracing is in effect, then we want to avoid polluting stderr
907 # with non-test commands. But once in "set -x" mode, we cannot prevent
908 # the shell from printing the "set +x" to turn it off (nor the saving
909 # of $? before that). But we can make sure that the output goes to
910 # /dev/null.
912 # There are a few subtleties here:
914 # - we have to redirect descriptor 4 in addition to 2, to cover
915 # BASH_XTRACEFD
917 # - the actual eval has to come before the redirection block (since
918 # it needs to see descriptor 4 to set up its stderr)
920 # - likewise, any error message we print must be outside the block to
921 # access descriptor 4
923 # - checking $? has to come immediately after the eval, but it must
924 # be _inside_ the block to avoid polluting the "set -x" output
927 test_eval_inner_ "$@" </dev/null >&3 2>&4
929 test_eval_ret_=$?
930 if want_trace
931 then
932 test 1 = $trace_level_ && set +x
933 trace_level_=$(($trace_level_-1))
935 } 2>/dev/null 4>&2
937 if test "$test_eval_ret_" != 0 && want_trace
938 then
939 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
941 return $test_eval_ret_
944 test_run_ () {
945 test_cleanup=:
946 expecting_failure=$2
948 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
949 # turn off tracing for this test-eval, as it simply creates
950 # confusing noise in the "-x" output
951 trace_tmp=$trace
952 trace=
953 # 117 is magic because it is unlikely to match the exit
954 # code of other programs
955 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)" ||
957 test "${GIT_TEST_CHAIN_LINT_HARDER:-${GIT_TEST_CHAIN_LINT_HARDER_DEFAULT:-1}}" != 0 &&
958 $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!')
960 then
961 BUG "broken &&-chain or run-away HERE-DOC: $1"
963 trace=$trace_tmp
966 setup_malloc_check
967 test_eval_ "$1"
968 eval_ret=$?
969 teardown_malloc_check
971 if test -z "$immediate" || test $eval_ret = 0 ||
972 test -n "$expecting_failure" && test "$test_cleanup" != ":"
973 then
974 setup_malloc_check
975 test_eval_ "$test_cleanup"
976 teardown_malloc_check
978 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
979 then
980 echo ""
982 return "$eval_ret"
985 test_start_ () {
986 test_count=$(($test_count+1))
987 maybe_setup_verbose
988 maybe_setup_valgrind
989 if test -n "$write_junit_xml"
990 then
991 junit_start=$(test-tool date getnanos)
995 test_finish_ () {
996 echo >&3 ""
997 maybe_teardown_valgrind
998 maybe_teardown_verbose
999 if test -n "$GIT_TEST_TEE_OFFSET"
1000 then
1001 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
1002 "$GIT_TEST_TEE_OUTPUT_FILE")
1006 test_skip () {
1007 to_skip=
1008 skipped_reason=
1009 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
1010 then
1011 to_skip=t
1012 skipped_reason="GIT_SKIP_TESTS"
1014 if test -z "$to_skip" && test -n "$run_list" &&
1015 ! match_test_selector_list '--run' "$1" $test_count "$run_list"
1016 then
1017 to_skip=t
1018 skipped_reason="--run"
1020 if test -z "$to_skip" && test -n "$test_prereq" &&
1021 ! test_have_prereq "$test_prereq"
1022 then
1023 to_skip=t
1025 of_prereq=
1026 if test "$missing_prereq" != "$test_prereq"
1027 then
1028 of_prereq=" of $test_prereq"
1030 skipped_reason="missing $missing_prereq${of_prereq}"
1033 case "$to_skip" in
1035 if test -n "$write_junit_xml"
1036 then
1037 message="$(xml_attr_encode "$skipped_reason")"
1038 write_junit_xml_testcase "$1" \
1039 " <skipped message=\"$message\" />"
1042 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1043 : true
1046 false
1048 esac
1051 # stub; perf-lib overrides it
1052 test_at_end_hook_ () {
1056 write_junit_xml () {
1057 case "$1" in
1058 --truncate)
1059 >"$junit_xml_path"
1060 junit_have_testcase=
1061 shift
1063 esac
1064 printf '%s\n' "$@" >>"$junit_xml_path"
1067 xml_attr_encode () {
1068 printf '%s\n' "$@" | test-tool xml-encode
1071 write_junit_xml_testcase () {
1072 junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1073 shift
1074 junit_attrs="$junit_attrs classname=\"$this_test\""
1075 junit_attrs="$junit_attrs time=\"$(test-tool \
1076 date getnanos $junit_start)\""
1077 write_junit_xml "$(printf '%s\n' \
1078 " <testcase $junit_attrs>" "$@" " </testcase>")"
1079 junit_have_testcase=t
1082 finalize_junit_xml () {
1083 if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1084 then
1085 test -n "$junit_have_testcase" || {
1086 junit_start=$(test-tool date getnanos)
1087 write_junit_xml_testcase "all tests skipped"
1090 # adjust the overall time
1091 junit_time=$(test-tool date getnanos $junit_suite_start)
1092 sed -e "s/\(<testsuite.*\) time=\"[^\"]*\"/\1/" \
1093 -e "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1094 -e '/^ *<\/testsuite/d' \
1095 <"$junit_xml_path" >"$junit_xml_path.new"
1096 mv "$junit_xml_path.new" "$junit_xml_path"
1098 write_junit_xml " </testsuite>" "</testsuites>"
1099 write_junit_xml=
1103 test_atexit_cleanup=:
1104 test_atexit_handler () {
1105 # In a succeeding test script 'test_atexit_handler' is invoked
1106 # twice: first from 'test_done', then from 'die' in the trap on
1107 # EXIT.
1108 # This condition and resetting 'test_atexit_cleanup' below makes
1109 # sure that the registered cleanup commands are run only once.
1110 test : != "$test_atexit_cleanup" || return 0
1112 setup_malloc_check
1113 test_eval_ "$test_atexit_cleanup"
1114 test_atexit_cleanup=:
1115 teardown_malloc_check
1118 test_done () {
1119 GIT_EXIT_OK=t
1121 # Run the atexit commands _before_ the trash directory is
1122 # removed, so the commands can access pidfiles and socket files.
1123 test_atexit_handler
1125 finalize_junit_xml
1127 if test -z "$HARNESS_ACTIVE"
1128 then
1129 mkdir -p "$TEST_RESULTS_DIR"
1131 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1132 total $test_count
1133 success $test_success
1134 fixed $test_fixed
1135 broken $test_broken
1136 failed $test_failure
1141 if test "$test_fixed" != 0
1142 then
1143 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1145 if test "$test_broken" != 0
1146 then
1147 say_color warn "# still have $test_broken known breakage(s)"
1149 if test "$test_broken" != 0 || test "$test_fixed" != 0
1150 then
1151 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1152 msg="remaining $test_remaining test(s)"
1153 else
1154 test_remaining=$test_count
1155 msg="$test_count test(s)"
1157 case "$test_failure" in
1159 if test $test_external_has_tap -eq 0
1160 then
1161 if test $test_remaining -gt 0
1162 then
1163 say_color pass "# passed all $msg"
1166 # Maybe print SKIP message
1167 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1168 case "$test_count" in
1170 say "1..$test_count${skip_all:+ $skip_all}"
1173 test -z "$skip_all" ||
1174 say_color warn "$skip_all"
1175 say "1..$test_count"
1177 esac
1180 if test -z "$debug" && test -n "$remove_trash"
1181 then
1182 test -d "$TRASH_DIRECTORY" ||
1183 error "Tests passed but trash directory already removed before test cleanup; aborting"
1185 cd "$TRASH_DIRECTORY/.." &&
1186 rm -fr "$TRASH_DIRECTORY" || {
1187 # try again in a bit
1188 sleep 5;
1189 rm -fr "$TRASH_DIRECTORY"
1190 } ||
1191 error "Tests passed but test cleanup failed; aborting"
1193 test_at_end_hook_
1195 exit 0 ;;
1198 if test $test_external_has_tap -eq 0
1199 then
1200 say_color error "# failed $test_failure among $msg"
1201 say "1..$test_count"
1204 exit 1 ;;
1206 esac
1209 if test -n "$valgrind"
1210 then
1211 make_symlink () {
1212 test -h "$2" &&
1213 test "$1" = "$(readlink "$2")" || {
1214 # be super paranoid
1215 if mkdir "$2".lock
1216 then
1217 rm -f "$2" &&
1218 ln -s "$1" "$2" &&
1219 rm -r "$2".lock
1220 else
1221 while test -d "$2".lock
1223 say "Waiting for lock on $2."
1224 sleep 1
1225 done
1230 make_valgrind_symlink () {
1231 # handle only executables, unless they are shell libraries that
1232 # need to be in the exec-path.
1233 test -x "$1" ||
1234 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1235 return;
1237 base=$(basename "$1")
1238 case "$base" in
1239 test-*)
1240 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1243 symlink_target="$GIT_BUILD_DIR/$base"
1245 esac
1246 # do not override scripts
1247 if test -x "$symlink_target" &&
1248 test ! -d "$symlink_target" &&
1249 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1250 then
1251 symlink_target=../valgrind.sh
1253 case "$base" in
1254 *.sh|*.perl)
1255 symlink_target=../unprocessed-script
1256 esac
1257 # create the link, or replace it if it is out of date
1258 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1261 # override all git executables in TEST_DIRECTORY/..
1262 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1263 mkdir -p "$GIT_VALGRIND"/bin
1264 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1266 make_valgrind_symlink $file
1267 done
1268 # special-case the mergetools loadables
1269 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1270 OLDIFS=$IFS
1271 IFS=:
1272 for path in $PATH
1274 ls "$path"/git-* 2> /dev/null |
1275 while read file
1277 make_valgrind_symlink "$file"
1278 done
1279 done
1280 IFS=$OLDIFS
1281 PATH=$GIT_VALGRIND/bin:$PATH
1282 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1283 export GIT_VALGRIND
1284 GIT_VALGRIND_MODE="$valgrind"
1285 export GIT_VALGRIND_MODE
1286 GIT_VALGRIND_ENABLED=t
1287 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1288 export GIT_VALGRIND_ENABLED
1289 elif test -n "$GIT_TEST_INSTALLED"
1290 then
1291 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1292 error "Cannot run git from $GIT_TEST_INSTALLED."
1293 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1294 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1295 else # normal case, use ../bin-wrappers only unless $with_dashes:
1296 if test -n "$no_bin_wrappers"
1297 then
1298 with_dashes=t
1299 else
1300 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1301 if ! test -x "$git_bin_dir/git"
1302 then
1303 if test -z "$with_dashes"
1304 then
1305 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1307 with_dashes=t
1309 PATH="$git_bin_dir:$PATH"
1311 GIT_EXEC_PATH=$GIT_BUILD_DIR
1312 if test -n "$with_dashes"
1313 then
1314 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1317 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1318 GIT_CONFIG_NOSYSTEM=1
1319 GIT_ATTR_NOSYSTEM=1
1320 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1322 if test -z "$GIT_TEST_CMP"
1323 then
1324 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1325 then
1326 GIT_TEST_CMP="$DIFF -c"
1327 else
1328 GIT_TEST_CMP="$DIFF -u"
1332 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1333 export GITPERLLIB
1334 test -d "$GIT_BUILD_DIR"/templates/blt || {
1335 error "You haven't built things yet, have you?"
1338 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1339 then
1340 echo >&2 'You need to build test-tool:'
1341 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1342 exit 1
1345 # Are we running this test at all?
1346 remove_trash=
1347 this_test=${0##*/}
1348 this_test=${this_test%%-*}
1349 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1350 then
1351 say_color info >&3 "skipping test $this_test altogether"
1352 skip_all="skip all tests in $this_test"
1353 test_done
1356 # Last-minute variable setup
1357 HOME="$TRASH_DIRECTORY"
1358 GNUPGHOME="$HOME/gnupg-home-not-used"
1359 export HOME GNUPGHOME
1361 # Test repository
1362 rm -fr "$TRASH_DIRECTORY" || {
1363 GIT_EXIT_OK=t
1364 echo >&5 "FATAL: Cannot prepare test area"
1365 exit 1
1368 remove_trash=t
1369 if test -z "$TEST_NO_CREATE_REPO"
1370 then
1371 git init "$TRASH_DIRECTORY" >&3 2>&4 ||
1372 error "cannot run git init"
1373 else
1374 mkdir -p "$TRASH_DIRECTORY"
1377 # Use -P to resolve symlinks in our working directory so that the cwd
1378 # in subprocesses like git equals our $PWD (for pathname comparisons).
1379 cd -P "$TRASH_DIRECTORY" || exit 1
1381 if test -n "$write_junit_xml"
1382 then
1383 junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1384 mkdir -p "$junit_xml_dir"
1385 junit_xml_base=${0##*/}
1386 junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1387 junit_attrs="name=\"${junit_xml_base%.sh}\""
1388 junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1389 date +%Y-%m-%dT%H:%M:%S)\""
1390 write_junit_xml --truncate "<testsuites>" " <testsuite $junit_attrs>"
1391 junit_suite_start=$(test-tool date getnanos)
1392 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1393 then
1394 GIT_TEST_TEE_OFFSET=0
1398 # Convenience
1399 # A regexp to match 5, 35 and 40 hexdigits
1400 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1401 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1402 _x40="$_x35$_x05"
1404 test_oid_init
1406 ZERO_OID=$(test_oid zero)
1407 OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1408 OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1409 EMPTY_TREE=$(test_oid empty_tree)
1410 EMPTY_BLOB=$(test_oid empty_blob)
1411 _z40=$ZERO_OID
1413 # Provide an implementation of the 'yes' utility; the upper bound
1414 # limit is there to help Windows that cannot stop this loop from
1415 # wasting cycles when the downstream stops reading, so do not be
1416 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1417 # limit the output of the yes utility", 2016-02-02)
1418 yes () {
1419 if test $# = 0
1420 then
1422 else
1423 y="$*"
1427 while test $i -lt 99
1429 echo "$y"
1430 i=$(($i+1))
1431 done
1434 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1435 # thus needs to be set up really early, and set an internal variable
1436 # for convenience so the hot test_set_prereq() codepath doesn't need
1437 # to call "git env--helper" (via test_bool_env). Only do that work
1438 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1439 GIT_TEST_FAIL_PREREQS_INTERNAL=
1440 if test -n "$GIT_TEST_FAIL_PREREQS"
1441 then
1442 if test_bool_env GIT_TEST_FAIL_PREREQS false
1443 then
1444 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1445 test_set_prereq FAIL_PREREQS
1447 else
1448 test_lazy_prereq FAIL_PREREQS '
1449 test_bool_env GIT_TEST_FAIL_PREREQS false
1453 # Fix some commands on Windows, and other OS-specific things
1454 uname_s=$(uname -s)
1455 case $uname_s in
1456 *MINGW*)
1457 # Windows has its own (incompatible) sort and find
1458 sort () {
1459 /usr/bin/sort "$@"
1461 find () {
1462 /usr/bin/find "$@"
1464 # git sees Windows-style pwd
1465 pwd () {
1466 builtin pwd -W
1468 # no POSIX permissions
1469 # backslashes in pathspec are converted to '/'
1470 # exec does not inherit the PID
1471 test_set_prereq MINGW
1472 test_set_prereq NATIVE_CRLF
1473 test_set_prereq SED_STRIPS_CR
1474 test_set_prereq GREP_STRIPS_CR
1475 test_set_prereq WINDOWS
1476 GIT_TEST_CMP=mingw_test_cmp
1478 *CYGWIN*)
1479 test_set_prereq POSIXPERM
1480 test_set_prereq EXECKEEPSPID
1481 test_set_prereq CYGWIN
1482 test_set_prereq SED_STRIPS_CR
1483 test_set_prereq GREP_STRIPS_CR
1484 test_set_prereq WINDOWS
1487 test_set_prereq POSIXPERM
1488 test_set_prereq BSLASHPSPEC
1489 test_set_prereq EXECKEEPSPID
1491 esac
1493 # Detect arches where a few things don't work
1494 uname_m=$(uname -m)
1495 case $uname_m in
1496 parisc* | hppa*)
1497 test_set_prereq HPPA
1499 esac
1501 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1502 test -z "$NO_PERL" && test_set_prereq PERL
1503 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1504 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1505 test -n "$USE_LIBPCRE2" && test_set_prereq PCRE
1506 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1507 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1509 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1510 then
1511 GIT_TEST_CHECK_CACHE_TREE=true
1512 export GIT_TEST_CHECK_CACHE_TREE
1515 test_lazy_prereq PIPE '
1516 # test whether the filesystem supports FIFOs
1517 test_have_prereq !MINGW,!CYGWIN &&
1518 rm -f testfifo && mkfifo testfifo
1521 test_lazy_prereq SYMLINKS '
1522 # test whether the filesystem supports symbolic links
1523 ln -s x y && test -h y
1526 test_lazy_prereq FILEMODE '
1527 test "$(git config --bool core.filemode)" = true
1530 test_lazy_prereq CASE_INSENSITIVE_FS '
1531 echo good >CamelCase &&
1532 echo bad >camelcase &&
1533 test "$(cat CamelCase)" != good
1536 test_lazy_prereq FUNNYNAMES '
1537 test_have_prereq !MINGW &&
1538 touch -- \
1539 "FUNNYNAMES tab embedded" \
1540 "FUNNYNAMES \"quote embedded\"" \
1541 "FUNNYNAMES newline
1542 embedded" 2>/dev/null &&
1543 rm -- \
1544 "FUNNYNAMES tab embedded" \
1545 "FUNNYNAMES \"quote embedded\"" \
1546 "FUNNYNAMES newline
1547 embedded" 2>/dev/null
1550 test_lazy_prereq UTF8_NFD_TO_NFC '
1551 # check whether FS converts nfd unicode to nfc
1552 auml=$(printf "\303\244")
1553 aumlcdiar=$(printf "\141\314\210")
1554 >"$auml" &&
1555 test -f "$aumlcdiar"
1558 test_lazy_prereq AUTOIDENT '
1559 sane_unset GIT_AUTHOR_NAME &&
1560 sane_unset GIT_AUTHOR_EMAIL &&
1561 git var GIT_AUTHOR_IDENT
1564 test_lazy_prereq EXPENSIVE '
1565 test -n "$GIT_TEST_LONG"
1568 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1569 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1572 test_lazy_prereq USR_BIN_TIME '
1573 test -x /usr/bin/time
1576 test_lazy_prereq NOT_ROOT '
1577 uid=$(id -u) &&
1578 test "$uid" != 0
1581 test_lazy_prereq JGIT '
1582 jgit --version
1585 # SANITY is about "can you correctly predict what the filesystem would
1586 # do by only looking at the permission bits of the files and
1587 # directories?" A typical example of !SANITY is running the test
1588 # suite as root, where a test may expect "chmod -r file && cat file"
1589 # to fail because file is supposed to be unreadable after a successful
1590 # chmod. In an environment (i.e. combination of what filesystem is
1591 # being used and who is running the tests) that lacks SANITY, you may
1592 # be able to delete or create a file when the containing directory
1593 # doesn't have write permissions, or access a file even if the
1594 # containing directory doesn't have read or execute permissions.
1596 test_lazy_prereq SANITY '
1597 mkdir SANETESTD.1 SANETESTD.2 &&
1599 chmod +w SANETESTD.1 SANETESTD.2 &&
1600 >SANETESTD.1/x 2>SANETESTD.2/x &&
1601 chmod -w SANETESTD.1 &&
1602 chmod -r SANETESTD.1/x &&
1603 chmod -rx SANETESTD.2 ||
1604 BUG "cannot prepare SANETESTD"
1606 ! test -r SANETESTD.1/x &&
1607 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1608 status=$?
1610 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1611 rm -rf SANETESTD.1 SANETESTD.2 ||
1612 BUG "cannot clean SANETESTD"
1613 return $status
1616 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1617 GIT_UNZIP=${GIT_UNZIP:-unzip}
1618 test_lazy_prereq UNZIP '
1619 "$GIT_UNZIP" -v
1620 test $? -ne 127
1623 run_with_limited_cmdline () {
1624 (ulimit -s 128 && "$@")
1627 test_lazy_prereq CMDLINE_LIMIT '
1628 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1629 run_with_limited_cmdline true
1632 run_with_limited_stack () {
1633 (ulimit -s 128 && "$@")
1636 test_lazy_prereq ULIMIT_STACK_SIZE '
1637 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1638 run_with_limited_stack true
1641 run_with_limited_open_files () {
1642 (ulimit -n 32 && "$@")
1645 test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1646 test_have_prereq !MINGW,!CYGWIN &&
1647 run_with_limited_open_files true
1650 build_option () {
1651 git version --build-options |
1652 sed -ne "s/^$1: //p"
1655 test_lazy_prereq LONG_IS_64BIT '
1656 test 8 -le "$(build_option sizeof-long)"
1659 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1660 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1662 test_lazy_prereq CURL '
1663 curl --version
1666 # SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1667 # which will not work with other hash algorithms and tests that work but don't
1668 # test anything meaningful (e.g. special values which cause short collisions).
1669 test_lazy_prereq SHA1 '
1670 case "$GIT_DEFAULT_HASH" in
1671 sha1) true ;;
1672 "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1673 *) false ;;
1674 esac
1677 test_lazy_prereq REBASE_P '
1678 test -z "$GIT_TEST_SKIP_REBASE_P"
1681 # Ensure that no test accidentally triggers a Git command
1682 # that runs the actual maintenance scheduler, affecting a user's
1683 # system permanently.
1684 # Tests that verify the scheduler integration must set this locally
1685 # to avoid errors.
1686 GIT_TEST_MAINT_SCHEDULER="none:exit 1"